## libselinux 2.5

=== debian/changelog ===
libselinux (2.5-3) unstable; urgency=medium

  * Team upload.
  * Do not try to mount /proc during the libselinux initialization, in some
    use cases /proc is not mounted at early boot and mounting/unmounting it
    later might cause race conditions. (Closes: #823184)

 -- Laurent Bigonville <bigon@debian.org>  Tue, 17 May 2016 14:04:22 +0200

libselinux (2.5-2) unstable; urgency=medium

  * Team upload.
  * d/p/only-mount-procfs-necessary.patch: Only mount /proc if necessary
    (Closes: #822679)

 -- Laurent Bigonville <bigon@debian.org>  Sat, 30 Apr 2016 11:56:40 +0200

libselinux (2.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - Bump libsepol1-dev build-dependency to >= 2.5 to match the release
    - debian/patches/fix-makefile-bugs.patch,
      debian/patches/fix-cross-compile.patch: Refreshed
    - Mount procfs before checking /proc/filesystems (Closes: #789218)
    - debian/libselinux1.symbols: Add new exported symbols
  * debian/gbp.conf: Sign tags by default
  * debian/control: Bump Standards-Version to 3.9.8 (no further changes)
  * debian/control: Fix Vcs-* URL's to please lintian (again)
  * debian/patches/fix-makefile-bugs.patch: Properly cleanup the files in
    clean-pywrap target, this way we are sure the python module is built with
    the correct version of python.

 -- Laurent Bigonville <bigon@debian.org>  Mon, 25 Apr 2016 13:18:24 +0200
