=== debian/changelog ===
libselinux (2.6-3) unstable; urgency=medium

  * Team upload.
  [ Christian Seiler ]
  * Add libselinux1-udeb (depended on by libmount1-udeb) (Closes: #835503)

 -- Laurent Bigonville <bigon@debian.org>  Sun, 06 Nov 2016 18:22:28 +0100

libselinux (2.6-2) unstable; urgency=medium

  * Team upload.
  * Fix python binding under python3, some strings were represented as arrays
    of bytes instead of python strings

 -- Laurent Bigonville <bigon@debian.org>  Sun, 06 Nov 2016 13:52:19 +0100

libselinux (2.6-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - Bump libsepol1-dev build-dependency to >= 2.6 to match the release
    - Make the build reproducible (Closes: #825655)
    - Drop 0003-Avoid-mounting-proc-outside-of-selinux_init_load_pol.patch,
      merged upstream
    - debian/patches/fix-makefile-bugs.patch,
      debian/patches/fix-cross-compile.patch: Refreshed
    - debian/python.mk: Fix python wrapper build
    - debian/libselinux1.symbols: Adjust the .symbols files, myprintf and
      obj_class_compat were never part of the public API
  * debian/libselinux1.symbols: Add the Build-Depends-Package field
  * debian/gbp.conf: Rename git-buildpackage section to buildpackage

 -- Laurent Bigonville <bigon@debian.org>  Sat, 29 Oct 2016 02:31:28 +0200
