=== debian/watch ===
version=3

https://github.com/SELinuxProject/selinux/wiki/Releases (?:.*)/releases/(?:\d*)/libselinux-([\d\.]*)\.tar\.gz
