=== debian/control ===
--- 
+++ 
@@ -3,20 +3,21 @@
 VCS-Browser: https://anonscm.debian.org/gitweb/?p=selinux/libselinux.git;a=summary
 Priority: optional
 Section: libs
-Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
-Uploaders: Manoj Srivastava <srivasta@debian.org>,
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
+Uploaders: Laurent Bigonville <bigon@debian.org>,
            Russell Coker <russell@coker.com.au>
-Standards-Version: 3.9.8
-Build-Depends: debhelper (>= 9),
-               dh-python,
+Standards-Version: 4.1.0
+Build-Depends: debhelper (>= 10),
+               dh-python <!nopython>,
                file,
-               gem2deb (>= 0.5.0~),
-               libsepol1-dev (>= 2.5),
+               gem2deb (>= 0.5.0~) <!noruby>,
+               libsepol1-dev (>= 2.7),
                libpcre3-dev,
                pkg-config,
-               python-all-dev (>= 2.6.6-3~),
-               python3-all-dev,
-               swig
+               python-all-dev (>= 2.6.6-3~) <!nopython>,
+               python3-all-dev <!nopython>,
+               swig <!nopython> <!noruby>
 X-Python-Version: >= 2.4
 X-Python3-Version: >= 3.2
 XS-Ruby-Versions: all
@@ -64,7 +65,7 @@
 Package: libselinux1-dev
 Architecture: linux-any
 Depends: libselinux1 (= ${binary:Version}),
-         libsepol1-dev (>= 2.5),
+         libsepol1-dev (>= 2.7),
          libpcre3-dev,
          ${misc:Depends}
 Section: libdevel
@@ -83,10 +84,34 @@
  control policies, including those based on the concepts of Type
  Enforcement, Role-based Access Control, and Multi-level Security.
 
+Package: libselinux1-udeb
+Architecture: linux-any
+Section: debian-installer
+Package-Type: udeb
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: SELinux runtime shared libraries
+ This package provides the shared libraries for Security-enhanced
+ Linux that provides interfaces (e.g. library functions for the
+ SELinux kernel APIs like getcon(), other support functions like
+ getseuserbyname()) to SELinux-aware applications. Security-enhanced
+ Linux is a patch of the Linux kernel and a number of utilities with
+ enhanced security functionality designed to add mandatory access
+ controls to Linux.  The Security-enhanced Linux kernel contains new
+ architectural components originally developed to improve the security
+ of the Flask operating system. These architectural components provide
+ general support for the enforcement of many kinds of mandatory access
+ control policies, including those based on the concepts of Type
+ Enforcement, Role-based Access Control, and Multi-level Security.
+ .
+ libselinux1-udeb provides the libselinux shared library for use within
+ the Debian installer. Do not install it on a normal system.
+
 Package: ruby-selinux
 Architecture: linux-any
 Depends: ruby | ruby-interpreter, ${misc:Depends}, ${shlibs:Depends}
 Section: ruby
+Build-Profiles: <!noruby>
 Description: Ruby bindings to SELinux shared libraries
  This package provides the Ruby bindings needed for developing Ruby
  SELinux applications.  Security-enhanced Linux is a patch of the
@@ -105,6 +130,7 @@
 Built-Using: ${Built-Using}
 Section: python
 Provides: ${python:Provides}
+Build-Profiles: <!nopython>
 Description: Python bindings to SELinux shared libraries
  This package provides the Python bindings needed for developing Python
  SELinux applications.
@@ -124,6 +150,7 @@
 Built-Using: ${Built-Using}
 Section: python
 Provides: ${python3:Provides}
+Build-Profiles: <!nopython>
 Description: Python3 bindings to SELinux shared libraries
  This package provides the Python3 bindings needed for developing Python
  SELinux applications.
