=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,10 @@
 DEB_HOST_GNU_CPU	:= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
 DEB_HOST_GNU_TYPE	:= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 DEB_HOST_MULTIARCH	:= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
-LIBDIR_LIBSEPOL		:= $(shell pkg-config --variable=libdir libsepol)
+PKG_CONFIG		?= $(DEB_HOST_GNU_TYPE)-pkg-config
+LIBDIR_LIBSEPOL		:= $(shell $(PKG_CONFIG) --variable=libdir libsepol)
+
+DOPACKAGES = $(shell dh_listpackages)
 
 PREFIX = /usr
 
@@ -32,26 +35,28 @@
 
 ## By default, pass everything through debhelper automatically
 export DH_OPTIONS
+DH_ADDONS =
+ifneq ($(filter python-selinux,$(DOPACKAGES)),)
+DH_ADDONS += --with=python2
+endif
+ifneq ($(filter python3-selinux,$(DOPACKAGES)),)
+DH_ADDONS += --with=python3
+endif
+ifneq ($(filter ruby-selinux,$(DOPACKAGES)),)
+DH_ADDONS += --with=ruby
+endif
 %: FORCE
-ifeq ($(DEB_STAGE),stage1)
-	@dh $@
-else
-	@dh $@ --with=python2,python3,ruby
-endif
+	@dh $@ $(DH_ADDONS)
 
 ## Don't try to rebuild the debian/rules file
 debian/rules:
 	@touch $@
 
-## Skip python/ruby packages during stage1 build
-ifeq ($(DEB_STAGE),stage1)
-DH_OPTIONS += -Npython-selinux -Nruby-selinux -Npython3-selinux
-endif
-
 ## Set up some variables to be passed to the upstream Makefile
 extra_make_args  = LIBSEPOLA=$(LIBDIR_LIBSEPOL)/libsepol.a
 extra_make_args += ARCH=$(DEB_HOST_GNU_CPU)
 extra_make_args += CC=$(DEB_HOST_GNU_TYPE)-gcc
+extra_make_args += PKG_CONFIG=$(PKG_CONFIG)
 override_dh_auto_build: FORCE
 	+$(MAKE) PREFIX="$(PREFIX)" LIBBASE="lib/${DEB_HOST_MULTIARCH}" $(extra_make_args) all
 
@@ -68,11 +73,11 @@
 	@# Fix up the broken library symlink
 	rm -f $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libselinux.so
 	ln -s /lib/$(DEB_HOST_MULTIARCH)/libselinux.so.1 $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libselinux.so
-ifneq ($(DEB_STAGE),stage1)
+ifneq ($(filter python-selinux python3-selinux,$(DOPACKAGES)),)
 	+$(MAKE) PREFIX="$(PREFIX)" $(python_extra_install_args) -f debian/python.mk
+endif
+ifneq ($(filter ruby-selinux,$(DOPACKAGES)),)
 	+$(MAKE) PREFIX="$(PREFIX)" $(extra_install_args) -f debian/ruby.mk
-else
-	@echo "Detected stage-1 bootstrap, skipping python/ruby bindings..."
 endif
 
 ## Generate a hard error for any upstream files we don't install
