=== debian/changelog ===
libselinux (2.8-1build2) disco; urgency=medium

  * No-change rebuild to build without python3.6 support.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 03 Nov 2018 11:51:24 +0000

libselinux (2.8-1build1) cosmic; urgency=medium

  * No-change rebuild to build for python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 28 Jun 2018 06:53:48 +0000

libselinux (2.8-1) unstable; urgency=medium

  * New upstream release
    - Bump libsepol1-dev build-dependency to >= 2.8 to match the release
  * debian/control: Update the VCS-* fields now that we have migrated to
    gitlab/salsa machine
  * debian/rules: Adjust to match upstream changes to the build system
  * debian/control: Downgrade libselinux1 to Priority: optional
  * debian/copyright: Fix a spelling error, thanks to lintian
  * debian/rules: Use ?= instead of := to assig the dpkg architecture
    variables, thanks to lintian
  * debian/control: Remove X-Python(3)-Version fields as the required version
    is already in oldstable, to please lintian
  * debian/rules: Use dh_missing --fail-missing instead of dh_install
  * debian/control: Bump Standards-Version to 4.1.4 (no further changes)
  * debian/rules: Pass -V to dh_makeshlibs to ensure the udeb file has a
    minimal version set

 -- Laurent Bigonville <bigon@debian.org>  Mon, 28 May 2018 20:50:31 +0200
